#ifndef __winOpeMode_h__
#define __winOpeMode_h__

#include "winLA.h"
#include "stdlib.h"
#include "winESC.h"
typedef struct{
	int priority;
	tokenData dt;
} saData;
typedef struct{
	TCHAR str[8];
	int priority;
} priorityData;
static tokenData (*saMode)();
tokenData opMode();
tokenData dtMode();
int contFlag=false;
priorityData pTab[]={
	{TEXT("("  ),  0},{TEXT(")"  ),  0},{TEXT("($" ),  0},{TEXT("["  ),  0},
	{TEXT("]"  ),  0},{TEXT("->" ),900},{TEXT("."  ),900},{TEXT("!"  ),800},
	{TEXT("~"  ),800},{TEXT("++" ),800},{TEXT("--" ),800},{TEXT("++$"),800},
	{TEXT("--$"),800},{TEXT("+$" ),800},{TEXT("-$" ),800},{TEXT("*$" ),800},
	{TEXT("&$" ),800},{TEXT("*"  ),700},{TEXT("/"  ),700},{TEXT("%"  ),700},
	{TEXT("+"  ),600},{TEXT("-"  ),600},{TEXT("<<" ),500},{TEXT(">>" ),500},
	{TEXT("<"  ),400},{TEXT("<=" ),400},{TEXT(">"  ),400},{TEXT(">=" ),400},
	{TEXT("==" ),350},{TEXT("!=" ),350},{TEXT("&"  ),330},{TEXT("^"  ),320},
	{TEXT("|"  ),300},{TEXT("&&" ),230},{TEXT("||" ),220},{TEXT("?"  ),210},
	{TEXT(":"  ),200},{TEXT("="  ),100},{TEXT("+=" ),100},{TEXT("-=" ),100},
	{TEXT("*=" ),100},{TEXT("/=" ),100},{TEXT("%=" ),100},{TEXT("&=" ),100},
	{TEXT("^=" ),100},{TEXT("|=" ),100},{TEXT("<<="),100},{TEXT(">>="),100},
	{TEXT(","  ), 50},{TEXT(""   ),  0}};

int setPriority(TCHAR str[]){
	for(int i=0;pTab[i].str[0]!=0;i++) if(lstrcmp(str, pTab[i].str)==0) return  pTab[i].priority;
	return -1;
}
void saStart(){
	La0Start();	saMode=dtMode;
}
void SyntaxError(int errNo, TCHAR str[]){
	TCHAR msg[256];err=errNo;
	wsprintf(msg,TEXT("*** Err %d Syntax Error \"%s\""),err,str);
	MessageBox(NULL, msg,TEXT("Error"),MB_OK);
}
tokenData dtMode(){
	tokenData r=LA();contFlag=false;
	if(r.type==FIN) return r;
	if(r.type==DLM){
		if     (lstrcmp(r.v.CH,TEXT("+" ))==0) {r.v.CH[1]='$';r.v.CH[2]=0;}
		else if(lstrcmp(r.v.CH,TEXT("-" ))==0) {r.v.CH[1]='$';r.v.CH[2]=0;}
		else if(lstrcmp(r.v.CH,TEXT("*" ))==0) {r.v.CH[1]='$';r.v.CH[2]=0;}
		else if(lstrcmp(r.v.CH,TEXT("&" ))==0) {r.v.CH[1]='$';r.v.CH[2]=0;}
		else if(lstrcmp(r.v.CH,TEXT("++"))==0) {r.v.CH[2]='$';r.v.CH[3]=0;}
		else if(lstrcmp(r.v.CH,TEXT("--"))==0) {r.v.CH[2]='$';r.v.CH[3]=0;}
		else if(lstrcmp(r.v.CH,TEXT(";" ))!=0 && 
		        lstrcmp(r.v.CH,TEXT("!" ))!=0 && 
			    lstrcmp(r.v.CH,TEXT("~" ))!=0 && 
				lstrcmp(r.v.CH,TEXT("(" ))!=0 && 
				lstrcmp(r.v.CH,TEXT(")" ))!=0 && 
				lstrcmp(r.v.CH,TEXT("}" ))!=0 &&
				lstrcmp(r.v.CH,TEXT("{" ))!=0) SyntaxError(101, r.v.CH);
		return r;
	}
	else{
		saMode=opMode;
		return r;
	}
}
tokenData opMode(){
	tokenData r=LA();contFlag=false;
	if(r.type==FIN) return r;
	if(r.type==DLM){
		if     (lstrcmp(r.v.CH,TEXT(")" ))==0) return r;
		else if(lstrcmp(r.v.CH,TEXT("]" ))==0) return r;
		else if(lstrcmp(r.v.CH,TEXT("++"))==0) return r;
		else if(lstrcmp(r.v.CH,TEXT("--"))==0) return r;
		else if(lstrcmp(r.v.CH,TEXT("(" ))==0) {r.v.CH[1]='$';r.v.CH[2]=0;}
		saMode=dtMode;
	}
	else {contFlag=true;saMode=dtMode;}
	return r;
}
#endif